## org.apache.batik.dom
Class AbstractElement

    java.lang.Object
      org.apache.batik.dom.AbstractNode
          org.apache.batik.dom.AbstractParentNode
              org.apache.batik.dom.AbstractParentChildNode
                  org.apache.batik.dom.AbstractElement

All Implemented Interfaces:
  java.io.Serializable, NodeEventTarget, ExtendedNode, NodeXBL, XBLManagerData, org.w3c.dom.Element, ElementTraversal, EventTarget, org.w3c.dom.Node

Direct Known Subclasses:
  AbstractElement, AbstractElementNS, GenericElement

    public abstract class AbstractElement

extends AbstractParentChildNode
implements org.w3c.dom.Element, ElementTraversal

This class implements the `Element` interface.

See Also:
  Serialized Form

Nested Class Summary
`class` `AbstractElement.ElementTypeInfo` Inner class to hold type information about this element.
`protected static class` `AbstractElement.Entry` To manage collisions in the attributes map.
`class` `AbstractElement.NamedNodeHashMap` An implementation of the `NamedNodeMap`.

Nested classes/interfaces inherited from class org.apache.batik.dom.AbstractParentNode
`AbstractParentNode.ChildNodes, AbstractParentNode.ElementsByTagName, AbstractParentNode.ElementsByTagNameNS`

Field Summary
`protected org.w3c.dom.NamedNodeMap` `attributes` The attributes of this element.
`protected org.w3c.dom.TypeInfo` `typeInfo` The element type information.

Fields inherited from class org.apache.batik.dom.AbstractParentChildNode
`nextSibling, parentNode, previousSibling`

Fields inherited from class org.apache.batik.dom.AbstractParentNode
`childNodes`

Fields inherited from class org.apache.batik.dom.AbstractNode
`DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, EMPTY_NODE_LIST, eventSupport, managerData, ownerDocument, userData, userDataHandlers`

Fields inherited from interface org.w3c.dom.Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

Constructor Summary
`protected` `AbstractElement()` Creates a new AbstractElement object.
`protected` `AbstractElement(java.lang.String name, AbstractDocument owner)` Creates a new AbstractElement object.

Method Summary
`protected void` `attrAdded(org.w3c.dom.Attr node, java.lang.String newv)` Called when an attribute has been added.
`protected void` `attrModified(org.w3c.dom.Attr node, java.lang.String oldv, java.lang.String newv)` Called when an attribute has been modified.
`protected void` `attrRemoved(org.w3c.dom.Attr node, java.lang.String oldv)` Called when an attribute has been removed.
`protected void` `checkChildType(org.w3c.dom.Node n, boolean replace)` Checks the validity of a node to be inserted.
`protected org.w3c.dom.Node` `copyInto(org.w3c.dom.Node n)` Copy the fields of the current node into the given node.
`protected org.w3c.dom.NamedNodeMap` `createAttributes()` Creates the attribute list.
`protected org.w3c.dom.Node` `deepCopyInto(org.w3c.dom.Node n)` Deeply copy the fields of the current node into the given node.
`protected org.w3c.dom.Node` `deepExport(org.w3c.dom.Node n, AbstractDocument d)` Deeply exports this node to the given document.
`protected org.w3c.dom.Node` `export(org.w3c.dom.Node n, AbstractDocument d)` Exports this node to the given document.
`void` `fireDOMAttrModifiedEvent(java.lang.String name, org.w3c.dom.Attr node, java.lang.String oldv, java.lang.String newv, short change)` Fires a DOMAttrModified event.
`java.lang.String` `getAttribute(java.lang.String name)` DOM: Implements `Element.getAttribute(String)`.
`org.w3c.dom.Attr` `getAttributeNode(java.lang.String name)` DOM: Implements `Element.getAttributeNode(String)`.
`org.w3c.dom.Attr` `getAttributeNodeNS(java.lang.String namespaceURI, java.lang.String localName)` DOM: Implements `Element.getAttributeNodeNS(String,String)`.
`java.lang.String` `getAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` DOM: Implements `Element.getAttributeNS(String,String)`.
`org.w3c.dom.NamedNodeMap` `getAttributes()` DOM: Implements `Node.getAttributes()`.
`int` `getChildElementCount()` DOM: Implements `ElementTraversal.getChildElementCount()`.
`org.w3c.dom.Element` `getFirstElementChild()` DOM: Implements `ElementTraversal.getFirstElementChild()`.
`protected java.lang.String` `getId()` Get the ID of this element.
`protected org.w3c.dom.Attr` `getIdAttribute()` Get an ID attribute.
`org.w3c.dom.Element` `getLastElementChild()` DOM: Implements `ElementTraversal.getLastElementChild()`.
`org.w3c.dom.Element` `getNextElementSibling()` DOM: Implements `ElementTraversal.getNextElementSibling()`.
`short` `getNodeType()` DOM: Implements `Node.getNodeType()`.
`org.w3c.dom.Element` `getPreviousElementSibling()` DOM: Implements `ElementTraversal.getPreviousElementSibling()`.
`org.w3c.dom.TypeInfo` `getSchemaTypeInfo()` DOM: Implements `Element.getSchemaTypeInfo()`.
`java.lang.String` `getTagName()` DOM: Implements `Element.getTagName()`.
`boolean` `hasAttribute(java.lang.String name)` DOM: Implements `Element.hasAttribute(String)`.
`boolean` `hasAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` DOM: Implements `Element.hasAttributeNS(String,String)`.
`boolean` `hasAttributes()` DOM: Implements `Node.hasAttributes()`.
`protected void` `nodeAdded(org.w3c.dom.Node node)` Called when a child node has been added.
`protected void` `nodeToBeRemoved(org.w3c.dom.Node node)` Called when a child node is going to be removed.
`void` `normalize()` DOM: Implements `Node.normalize()`.
`void` `removeAttribute(java.lang.String name)` DOM: Implements `Element.removeAttribute(String)`.
`org.w3c.dom.Attr` `removeAttributeNode(org.w3c.dom.Attr oldAttr)` DOM: Implements `Element.removeAttributeNode(Attr)`.
`void` `removeAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` DOM: Implements `Element.removeAttributeNS(String,String)`.
`void` `setAttribute(java.lang.String name, java.lang.String value)` DOM: Implements `Element.setAttribute(String,String)`.
`org.w3c.dom.Attr` `setAttributeNode(org.w3c.dom.Attr newAttr)` DOM: Implements `Element.setAttributeNode(Attr)`.
`org.w3c.dom.Attr` `setAttributeNodeNS(org.w3c.dom.Attr newAttr)` DOM: Implements `Element.setAttributeNodeNS(Attr)`.
`void` `setAttributeNS(java.lang.String namespaceURI, java.lang.String qualifiedName, java.lang.String value)` DOM: Implements `Element.setAttributeNS(String,String,String)`.
`void` `setIdAttribute(java.lang.String name, boolean isId)` DOM: Implements `Element.setIdAttribute(String,boolean)`.
`void` `setIdAttributeNode(org.w3c.dom.Attr attr, boolean isId)` DOM: Implements `Element.setIdAttributeNode(Attr,boolean)`.
`void` `setIdAttributeNS(java.lang.String ns, java.lang.String ln, boolean isId)` DOM: Implements `Element.setIdAttributeNS(String,String,boolean)`.

Methods inherited from class org.apache.batik.dom.AbstractParentChildNode
`getNextSibling, getParentNode, getPreviousSibling, setNextSibling, setParentNode, setPreviousSibling`

Methods inherited from class org.apache.batik.dom.AbstractParentNode
`appendChild, checkAndRemove, fireDOMNodeInsertedEvent, fireDOMNodeInsertedIntoDocumentEvent, fireDOMNodeRemovedEvent, fireDOMNodeRemovedFromDocumentEvent, fireDOMSubtreeModifiedEvent, getChildNodes, getElementsByTagName, getElementsByTagNameNS, getFirstChild, getLastChild, getTextContent, hasChildNodes, insertBefore, removeChild, replaceChild`

Methods inherited from class org.apache.batik.dom.AbstractNode

`addEventListener, addEventListenerNS, cloneNode, compareDocumentPosition, compareNamedNodeMaps, compareStrings, createDOMException, dispatchEvent, fireDOMCharacterDataModifiedEvent, fireUserDataHandlers, getBaseURI, getBaseURI, getCascadedXMLBase, getCurrentDocument, getEventSupport, getFeature, getLocalName, getManagerData, getNamespaceURI, getNodeValue, getOwnerDocument, getParentNodeEventTarget, getPrefix, getUserData, getXblBoundElement, getXblChildNodes, getXblDefinitions, getXblFirstChild, getXblFirstElementChild, getXblLastChild, getXblLastElementChild, getXblNextElementSibling, getXblNextSibling, getXblParentNode, getXblPreviousElementSibling, getXblPreviousSibling, getXblScopedChildNodes, getXblShadowTree, hasEventListenerNS, initializeEventSupport, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespacePrefix, lookupNamespaceURI, lookupPrefix, newNode, removeEventListener, removeEventListenerNS, setManagerData, setNodeName, setNodeValue, setOwnerDocument, setPrefix, setSpecified, setTextContent, setUserData, willTriggerNS`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.w3c.dom.Element
`getElementsByTagName, getElementsByTagNameNS`

Methods inherited from interface org.w3c.dom.Node

`appendChild, cloneNode, compareDocumentPosition, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

Methods inherited from interface org.apache.batik.dom.ExtendedNode
`isReadonly, setReadonly`

Field Detail

### attributes

    protected org.w3c.dom.NamedNodeMap attributes

  The attributes of this element.

### typeInfo

    protected org.w3c.dom.TypeInfo typeInfo

  The element type information.

Constructor Detail

### AbstractElement

    protected AbstractElement()

  Creates a new AbstractElement object.

### AbstractElement

    protected AbstractElement(java.lang.String name,
                              AbstractDocument owner)

  Creates a new AbstractElement object.

  Parameters:
    `name` - The element name for validation purposes.
    `owner` - The owner document.
  Throws:
    `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: if name contains invalid characters,

Method Detail

### getNodeType

    public short getNodeType()

  DOM: Implements `Node.getNodeType()`.

  Specified by:
    `getNodeType` in interface `org.w3c.dom.Node`
  Returns:
    `Node.ELEMENT_NODE`

### hasAttributes

    public boolean hasAttributes()

  DOM: Implements `Node.hasAttributes()`.

  Specified by:
    `hasAttributes` in interface `org.w3c.dom.Node`
  Overrides:
    `hasAttributes` in class `AbstractNode`
  Returns:
    false.

### getAttributes

    public org.w3c.dom.NamedNodeMap getAttributes()

  DOM: Implements `Node.getAttributes()`.

  Specified by:
    `getAttributes` in interface `org.w3c.dom.Node`
  Overrides:
    `getAttributes` in class `AbstractNode`
  Returns:
    null.

### getTagName

    public java.lang.String getTagName()

  DOM: Implements `Element.getTagName()`.

  Specified by:
    `getTagName` in interface `org.w3c.dom.Element`
  Returns:
    `Node.getNodeName()`.

### hasAttribute

    public boolean hasAttribute(java.lang.String name)

  DOM: Implements `Element.hasAttribute(String)`.

  Specified by:
    `hasAttribute` in interface `org.w3c.dom.Element`

### getAttribute

    public java.lang.String getAttribute(java.lang.String name)

  DOM: Implements `Element.getAttribute(String)`.

  Specified by:
    `getAttribute` in interface `org.w3c.dom.Element`

### setAttribute

    public void setAttribute(java.lang.String name,
                             java.lang.String value)
                      throws org.w3c.dom.DOMException

  DOM: Implements `Element.setAttribute(String,String)`.

  Specified by:
    `setAttribute` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### removeAttribute

    public void removeAttribute(java.lang.String name)
                         throws org.w3c.dom.DOMException

  DOM: Implements `Element.removeAttribute(String)`.

  Specified by:
    `removeAttribute` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### getAttributeNode

    public org.w3c.dom.Attr getAttributeNode(java.lang.String name)

  DOM: Implements `Element.getAttributeNode(String)`.

  Specified by:
    `getAttributeNode` in interface `org.w3c.dom.Element`

### setAttributeNode

    public org.w3c.dom.Attr setAttributeNode(org.w3c.dom.Attr newAttr)
                                      throws org.w3c.dom.DOMException

  DOM: Implements `Element.setAttributeNode(Attr)`.

  Specified by:
    `setAttributeNode` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### removeAttributeNode

    public org.w3c.dom.Attr removeAttributeNode(org.w3c.dom.Attr oldAttr)
                                         throws org.w3c.dom.DOMException

  DOM: Implements `Element.removeAttributeNode(Attr)`.

  Specified by:
    `removeAttributeNode` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### normalize

    public void normalize()

  DOM: Implements `Node.normalize()`.

  Specified by:
    `normalize` in interface `org.w3c.dom.Node`
  Overrides:
    `normalize` in class `AbstractParentNode`

### hasAttributeNS

    public boolean hasAttributeNS(java.lang.String namespaceURI,
                                  java.lang.String localName)

  DOM: Implements `Element.hasAttributeNS(String,String)`.

  Specified by:
    `hasAttributeNS` in interface `org.w3c.dom.Element`

### getAttributeNS

    public java.lang.String getAttributeNS(java.lang.String namespaceURI,
                                           java.lang.String localName)

  DOM: Implements `Element.getAttributeNS(String,String)`.

  Specified by:
    `getAttributeNS` in interface `org.w3c.dom.Element`

### setAttributeNS

    public void setAttributeNS(java.lang.String namespaceURI,
                               java.lang.String qualifiedName,
                               java.lang.String value)
                        throws org.w3c.dom.DOMException

  DOM: Implements `Element.setAttributeNS(String,String,String)`.

  Specified by:
    `setAttributeNS` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### removeAttributeNS

    public void removeAttributeNS(java.lang.String namespaceURI,
                                  java.lang.String localName)
                           throws org.w3c.dom.DOMException

  DOM: Implements `Element.removeAttributeNS(String,String)`.

  Specified by:
    `removeAttributeNS` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### getAttributeNodeNS

    public org.w3c.dom.Attr getAttributeNodeNS(java.lang.String namespaceURI,
                                               java.lang.String localName)

  DOM: Implements `Element.getAttributeNodeNS(String,String)`.

  Specified by:
    `getAttributeNodeNS` in interface `org.w3c.dom.Element`

### setAttributeNodeNS

    public org.w3c.dom.Attr setAttributeNodeNS(org.w3c.dom.Attr newAttr)
                                        throws org.w3c.dom.DOMException

  DOM: Implements `Element.setAttributeNodeNS(Attr)`.

  Specified by:
    `setAttributeNodeNS` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### getSchemaTypeInfo

    public org.w3c.dom.TypeInfo getSchemaTypeInfo()

  DOM: Implements `Element.getSchemaTypeInfo()`.

  Specified by:
    `getSchemaTypeInfo` in interface `org.w3c.dom.Element`

### setIdAttribute

    public void setIdAttribute(java.lang.String name,
                               boolean isId)
                        throws org.w3c.dom.DOMException

  DOM: Implements `Element.setIdAttribute(String,boolean)`.

  Specified by:
    `setIdAttribute` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### setIdAttributeNS

    public void setIdAttributeNS(java.lang.String ns,
                                 java.lang.String ln,
                                 boolean isId)
                          throws org.w3c.dom.DOMException

  DOM: Implements `Element.setIdAttributeNS(String,String,boolean)`.

  Specified by:
    `setIdAttributeNS` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### setIdAttributeNode

    public void setIdAttributeNode(org.w3c.dom.Attr attr,
                                   boolean isId)
                            throws org.w3c.dom.DOMException

  DOM: Implements `Element.setIdAttributeNode(Attr,boolean)`.

  Specified by:
    `setIdAttributeNode` in interface `org.w3c.dom.Element`
  Throws:
    `org.w3c.dom.DOMException`

### getIdAttribute

    protected org.w3c.dom.Attr getIdAttribute()

  Get an ID attribute.

### getId

    protected java.lang.String getId()

  Get the ID of this element.

### nodeAdded

    protected void nodeAdded(org.w3c.dom.Node node)

  Called when a child node has been added.

  Overrides:
    `nodeAdded` in class `AbstractParentNode`

### nodeToBeRemoved

    protected void nodeToBeRemoved(org.w3c.dom.Node node)

  Called when a child node is going to be removed.

  Overrides:
    `nodeToBeRemoved` in class `AbstractParentNode`

### createAttributes

    protected org.w3c.dom.NamedNodeMap createAttributes()

  Creates the attribute list.

### export

    protected org.w3c.dom.Node export(org.w3c.dom.Node n,
                                      AbstractDocument d)

  Exports this node to the given document.

  Overrides:
    `export` in class `AbstractNode`
  Parameters:
    `n` - The clone node.
    `d` - The destination document.

### deepExport

    protected org.w3c.dom.Node deepExport(org.w3c.dom.Node n,
                                          AbstractDocument d)

  Deeply exports this node to the given document.

  Overrides:
    `deepExport` in class `AbstractParentNode`
  Parameters:
    `n` - The clone node.
    `d` - The destination document.

### copyInto

    protected org.w3c.dom.Node copyInto(org.w3c.dom.Node n)

  Copy the fields of the current node into the given node.

  Overrides:
    `copyInto` in class `AbstractNode`
  Parameters:
    `n` - a node of the type of this.

### deepCopyInto

    protected org.w3c.dom.Node deepCopyInto(org.w3c.dom.Node n)

  Deeply copy the fields of the current node into the given node.

  Overrides:
    `deepCopyInto` in class `AbstractParentNode`
  Parameters:
    `n` - a node of the type of this.

### checkChildType

    protected void checkChildType(org.w3c.dom.Node n,
                                  boolean replace)

  Checks the validity of a node to be inserted.

  Overrides:
    `checkChildType` in class `AbstractNode`
  Parameters:
    `n` - The node to be inserted.

### fireDOMAttrModifiedEvent

    public void fireDOMAttrModifiedEvent(java.lang.String name,
                                         org.w3c.dom.Attr node,
                                         java.lang.String oldv,
                                         java.lang.String newv,
                                         short change)

  Fires a DOMAttrModified event. WARNING: public accessor because of compilation problems on Solaris. Do not change.

  Parameters:
    `name` - The attribute's name.
    `node` - The attribute's node.
    `oldv` - The old value of the attribute.
    `newv` - The new value of the attribute.
    `change` - The modification type.

### attrAdded

    protected void attrAdded(org.w3c.dom.Attr node,
                             java.lang.String newv)

  Called when an attribute has been added.

### attrModified

    protected void attrModified(org.w3c.dom.Attr node,
                                java.lang.String oldv,
                                java.lang.String newv)

  Called when an attribute has been modified.

### attrRemoved

    protected void attrRemoved(org.w3c.dom.Attr node,
                               java.lang.String oldv)

  Called when an attribute has been removed.

### getFirstElementChild

    public org.w3c.dom.Element getFirstElementChild()

  DOM: Implements `ElementTraversal.getFirstElementChild()`.

  Specified by:
    `getFirstElementChild` in interface `ElementTraversal`

### getLastElementChild

    public org.w3c.dom.Element getLastElementChild()

  DOM: Implements `ElementTraversal.getLastElementChild()`.

  Specified by:
    `getLastElementChild` in interface `ElementTraversal`

### getNextElementSibling

    public org.w3c.dom.Element getNextElementSibling()

  DOM: Implements `ElementTraversal.getNextElementSibling()`.

  Specified by:
    `getNextElementSibling` in interface `ElementTraversal`

### getPreviousElementSibling

    public org.w3c.dom.Element getPreviousElementSibling()

  DOM: Implements `ElementTraversal.getPreviousElementSibling()`.

  Specified by:
    `getPreviousElementSibling` in interface `ElementTraversal`

### getChildElementCount

    public int getChildElementCount()

  DOM: Implements `ElementTraversal.getChildElementCount()`.

  Specified by:
    `getChildElementCount` in interface `ElementTraversal`

Copyright © 2008 Apache Software Foundation. All Rights Reserved.